/*
 * jpegenc.c
 *
 *  Created on: Jul 27, 2009
 *      Author: Administrator
 */

#include "ssd192x.h"
#include "type.h"
#include "jpeg_enc.h"
#include "utils.h"
#include "lcd.h"
#include "main.h"
#include "uart0.h"

#include <TinyFS\tff.h>
#include <string.h>


UINT8 jpeg_encode[];
UINT32 jfilesize;
UINT32 max_size;

extern UINT32 SET_CAM_WIDTH;
extern UINT32 SET_CAM_HEIGHT;

static INT32 reg_init[][2]={
      {REG_FRC_FRAME_CTL                ,0x00},   // Reg   334h
      {REG_FRC_ENABLE                   ,0x00},   // Reg   336h
      {REG_JPEG_RESIZER_CTL             ,0x00},   // Reg   360h
      {REG_JPEG_CTRL                    ,0x00},   // Reg   380h
      {REG_JPEG_RAW_STATUS              ,0x00},   // Reg   384h
      {REG_JPEG_START_STOP              ,0x00},   // Reg   38ah
      {REG_JPEG_FIFO_SIZE               ,0x00},   // Reg   3a4h
      {REG_JPEG_ENCODE_SIZE_LIMIT_0     ,0x00},   // Reg   3b0h
      {REG_JPEG_ENCODE_SIZE_LIMIT_1     ,0x00},   // Reg   3b1h
      {REG_JPEG_ENCODE_SIZE_LIMIT_2     ,0x00},   // Reg   3b2h

      {REG_JPEG_FILE_SIZE_0             ,0x00},   // Reg   3b8h
      {REG_JPEG_FILE_SIZE_1             ,0x00},   // Reg   3b9h
      {REG_JPEG_FILE_SIZE_2             ,0x00},   // Reg   3bah

      {REG_JPEG_OP_MODE_ENC             ,0x00},   // Reg   400h

      {REG_JPEG_CMD                     ,0x80},   // Reg   402h

      {REG_JPEG_DECODE_VALUE            ,0x00},   // Reg   404h

      {REG_JPEG_Y_PIXEL_SIZE_0          ,0x00},   // Reg   40ch
      {REG_JPEG_Y_PIXEL_SIZE_1          ,0x00},   // Reg   40dh
      {REG_JPEG_X_PIXEL_SIZE_0          ,0x00},   // Reg   40eh
      {REG_JPEG_X_PIXEL_SIZE_1          ,0x00},   // Reg   40fh

      {REG_JPEG_SRC_START_ADDR_0        ,0x00},   // Reg   410h
      {REG_JPEG_SRC_START_ADDR_1        ,0x00},   // Reg   411h
      {REG_JPEG_SRC_START_ADDR_2        ,0x00},   // Reg   412h
      {REG_JPEG_SRC_START_ADDR_3        ,0x00},   // Reg   413h

      {REG_JPEG_DEST_START_ADDR_0       ,0x00},   // Reg   414h
      {REG_JPEG_DEST_START_ADDR_1       ,0x00},   // Reg   415h
      {REG_JPEG_DEST_START_ADDR_2       ,0x00},   // Reg   416h
      {REG_JPEG_DEST_START_ADDR_3       ,0x00},   // Reg   417h

      {REG_JPEG_RST_MARKER_STATUS       ,0x00},   // Reg   41eh

      {REG_JPEG_INSERT_MARKER00         ,0xff},   // Reg   420
      {REG_JPEG_INSERT_MARKER01         ,0xfe},   // Reg   422

      {REG_JPEG_MARKER_LENGTH00         ,0x00},   // Reg   424
      {REG_JPEG_MARKER_LENGTH01         ,0x22},   // Reg   426

      {REG_JPEG_MARKER_DATA_00          ,0x05},   // Reg   428
      {REG_JPEG_MARKER_DATA_01          ,0x06},   // Reg   42a
      {REG_JPEG_MARKER_DATA_02          ,0xff},   // Reg   42c
      {REG_JPEG_MARKER_DATA_03          ,0xff},   // Reg   42e
      {REG_JPEG_MARKER_DATA_04          ,0xff},   // Reg   430
      {REG_JPEG_MARKER_DATA_05          ,0xff},   // Reg   432
      {REG_JPEG_MARKER_DATA_06          ,0xff},   // Reg   434
      {REG_JPEG_MARKER_DATA_07          ,0xff},   // Reg   436
      {REG_JPEG_MARKER_DATA_08          ,0xff},   // Reg   438
      {REG_JPEG_MARKER_DATA_09          ,0xff},   // Reg   43a
      {REG_JPEG_MARKER_DATA_10          ,0xff},   // Reg   43c
      {REG_JPEG_MARKER_DATA_11          ,0xff},   // Reg   43e
      {REG_JPEG_MARKER_DATA_12          ,0xff},   // Reg   440
      {REG_JPEG_MARKER_DATA_13          ,0xff},   // Reg   442
      {REG_JPEG_MARKER_DATA_14          ,0xff},   // Reg   444
      {REG_JPEG_MARKER_DATA_15          ,0xff},   // Reg   446
      {REG_JPEG_MARKER_DATA_16          ,0xff},   // Reg   448
      {REG_JPEG_MARKER_DATA_17          ,0xff},   // Reg   44a
      {REG_JPEG_MARKER_DATA_18          ,0xff},   // Reg   44c
      {REG_JPEG_MARKER_DATA_19          ,0xff},   // Reg   44e
      {REG_JPEG_MARKER_DATA_20          ,0xff},   // Reg   450
      {REG_JPEG_MARKER_DATA_21          ,0xff},   // Reg   452
      {REG_JPEG_MARKER_DATA_22          ,0xff},   // Reg   454
      {REG_JPEG_MARKER_DATA_23          ,0xff},   // Reg   456
      {REG_JPEG_MARKER_DATA_24          ,0xff},   // Reg   458
      {REG_JPEG_MARKER_DATA_25          ,0xff},   // Reg   45a
      {REG_JPEG_MARKER_DATA_26          ,0xff},   // Reg   45c
      {REG_JPEG_MARKER_DATA_27          ,0xff},   // Reg   45e
      {REG_JPEG_MARKER_DATA_28          ,0xff},   // Reg   460
      {REG_JPEG_MARKER_DATA_29          ,0xff},   // Reg   462
      {REG_JPEG_MARKER_DATA_30          ,0x30},   // Reg   464
      {REG_JPEG_MARKER_DATA_31          ,0x31},   // Reg   466

      {REG_JPEG_SOI_CONST_00            ,0xff},   // Reg   468
      {REG_JPEG_SOI_CONST_01            ,0xd8},   // Reg   46a

      {REG_JPEG_JFIF_CONST_00           ,0xff},   // Reg   46c
      {REG_JPEG_JFIF_CONST_01           ,0xe0},   // Reg   46e
      {REG_JPEG_JFIF_CONST_02           ,0x00},   // Reg   470
      {REG_JPEG_JFIF_CONST_03           ,0x10},   // Reg   472
      {REG_JPEG_JFIF_CONST_04           ,0x4a},   // Reg   474
      {REG_JPEG_JFIF_CONST_05           ,0x46},   // Reg   476
      {REG_JPEG_JFIF_CONST_06           ,0x49},   // Reg   478
      {REG_JPEG_JFIF_CONST_07           ,0x46},   // Reg   47a
      {REG_JPEG_JFIF_CONST_08           ,0x00},   // Reg   47c
      {REG_JPEG_JFIF_CONST_09           ,0x01},   // Reg   47e
      {REG_JPEG_JFIF_CONST_10           ,0x02},   // Reg   480
      {REG_JPEG_JFIF_CONST_11           ,0x00},   // Reg   482
      {REG_JPEG_JFIF_CONST_12           ,0x00},   // Reg   484
      {REG_JPEG_JFIF_CONST_13           ,0x01},   // Reg   486
      {REG_JPEG_JFIF_CONST_14           ,0x00},   // Reg   488
      {REG_JPEG_JFIF_CONST_15           ,0x01},   // Reg   48a
      {REG_JPEG_JFIF_CONST_16           ,0x00},   // Reg   48c
      {REG_JPEG_JFIF_CONST_17           ,0x00},   // Reg   48e

      {REG_JPEG_LUM_DC_HT_CONST_00      ,0xff},   // Reg   490
      {REG_JPEG_LUM_DC_HT_CONST_01      ,0xc4},   // Reg   492
      {REG_JPEG_LUM_DC_HT_CONST_02      ,0x00},   // Reg   494
      {REG_JPEG_LUM_DC_HT_CONST_03      ,0x1f},   // Reg   496
      {REG_JPEG_LUM_DC_HT_CONST_04      ,0x00},   // Reg   498

      {REG_JPEG_CHR_DC_HT_CONST_00      ,0xff},   // Reg   4a0
      {REG_JPEG_CHR_DC_HT_CONST_01      ,0xc4},   // Reg   4a2
      {REG_JPEG_CHR_DC_HT_CONST_02      ,0x00},   // Reg   4a4
      {REG_JPEG_CHR_DC_HT_CONST_03      ,0x1f},   // Reg   4a6
      {REG_JPEG_CHR_DC_HT_CONST_04      ,0x01},   // Reg   4a8

      {REG_JPEG_LUM_AC_HT_CONST_00      ,0xff},   // Reg   4b0
      {REG_JPEG_LUM_AC_HT_CONST_01      ,0xc4},   // Reg   4b2
      {REG_JPEG_LUM_AC_HT_CONST_02      ,0x00},   // Reg   4b4
      {REG_JPEG_LUM_AC_HT_CONST_03      ,0xb5},   // Reg   4b6
      {REG_JPEG_LUM_AC_HT_CONST_04      ,0x10},   // Reg   4b8

      {REG_JPEG_CHR_AC_HT_CONST_00      ,0xff},   // Reg   4c0
      {REG_JPEG_CHR_AC_HT_CONST_01      ,0xc4},   // Reg   4c2
      {REG_JPEG_CHR_AC_HT_CONST_02      ,0x00},   // Reg   4c4
      {REG_JPEG_CHR_AC_HT_CONST_03      ,0xb5},   // Reg   4c6
      {REG_JPEG_CHR_AC_HT_CONST_04      ,0x11},   // Reg   4c8

      {REG_JPEG_LUM_QT_CONST_00         ,0xff},   // Reg   4d0
      {REG_JPEG_LUM_QT_CONST_01         ,0xdb},   // Reg   4d2
      {REG_JPEG_LUM_QT_CONST_02         ,0x00},   // Reg   4d4
      {REG_JPEG_LUM_QT_CONST_03         ,0x43},   // Reg   4d6
      {REG_JPEG_LUM_QT_CONST_04         ,0x00},   // Reg   4d8

      {REG_JPEG_CHR_QT_CONST_00         ,0xff},   // Reg   4e0
      {REG_JPEG_CHR_QT_CONST_01         ,0xdb},   // Reg   4e2
      {REG_JPEG_CHR_QT_CONST_02         ,0x00},   // Reg   4e4
      {REG_JPEG_CHR_QT_CONST_03         ,0x43},   // Reg   4e6
      {REG_JPEG_CHR_QT_CONST_04         ,0x01},   // Reg   4e8

      {REG_JPEG_SOF_CONST_00            ,0xff},   // Reg   4f0
      {REG_JPEG_SOF_CONST_01            ,0xc0},   // Reg   4f2
      {REG_JPEG_SOF_CONST_02            ,0x00},   // Reg   4f4
      {REG_JPEG_SOF_CONST_03            ,0x11},   // Reg   4f6
      {REG_JPEG_SOF_CONST_04            ,0x08},   // Reg   4f8

      {REG_JPEG_QUANT_T0_00             ,0x10},   // Reg   500
      {REG_JPEG_QUANT_T0_01             ,0x0b},   // Reg   502
      {REG_JPEG_QUANT_T0_02             ,0x0c},   // Reg   504
      {REG_JPEG_QUANT_T0_03             ,0x0e},   // Reg   506
      {REG_JPEG_QUANT_T0_04             ,0x0c},   // Reg   508
      {REG_JPEG_QUANT_T0_05             ,0x0a},   // Reg   50a
      {REG_JPEG_QUANT_T0_06             ,0x10},   // Reg   50c
      {REG_JPEG_QUANT_T0_07             ,0x0e},   // Reg   50e
      {REG_JPEG_QUANT_T0_08             ,0x0d},   // Reg   510
      {REG_JPEG_QUANT_T0_09             ,0x0e},   // Reg   512
      {REG_JPEG_QUANT_T0_10             ,0x12},   // Reg   514
      {REG_JPEG_QUANT_T0_11             ,0x11},   // Reg   516
      {REG_JPEG_QUANT_T0_12             ,0x10},   // Reg   518
      {REG_JPEG_QUANT_T0_13             ,0x13},   // Reg   51a
      {REG_JPEG_QUANT_T0_14             ,0x18},   // Reg   51c
      {REG_JPEG_QUANT_T0_15             ,0x28},   // Reg   51e
      {REG_JPEG_QUANT_T0_16             ,0x1a},   // Reg   520
      {REG_JPEG_QUANT_T0_17             ,0x18},   // Reg   522
      {REG_JPEG_QUANT_T0_18             ,0x16},   // Reg   524
      {REG_JPEG_QUANT_T0_19             ,0x16},   // Reg   526
      {REG_JPEG_QUANT_T0_20             ,0x18},   // Reg   528
      {REG_JPEG_QUANT_T0_21             ,0x31},   // Reg   52a
      {REG_JPEG_QUANT_T0_22             ,0x23},   // Reg   52c
      {REG_JPEG_QUANT_T0_23             ,0x25},   // Reg   52e
      {REG_JPEG_QUANT_T0_24             ,0x1d},   // Reg   530
      {REG_JPEG_QUANT_T0_25             ,0x28},   // Reg   532
      {REG_JPEG_QUANT_T0_26             ,0x3a},   // Reg   534
      {REG_JPEG_QUANT_T0_27             ,0x33},   // Reg   536
      {REG_JPEG_QUANT_T0_28             ,0x3d},   // Reg   538
      {REG_JPEG_QUANT_T0_29             ,0x3c},   // Reg   53a
      {REG_JPEG_QUANT_T0_30             ,0x39},   // Reg   53c
      {REG_JPEG_QUANT_T0_31             ,0x33},   // Reg   53e
      {REG_JPEG_QUANT_T0_32             ,0x38},   // Reg   540
      {REG_JPEG_QUANT_T0_33             ,0x37},   // Reg   542
      {REG_JPEG_QUANT_T0_34             ,0x40},   // Reg   544
      {REG_JPEG_QUANT_T0_35             ,0x48},   // Reg   546
      {REG_JPEG_QUANT_T0_36             ,0x5c},   // Reg   548
      {REG_JPEG_QUANT_T0_37             ,0x4e},   // Reg   54a
      {REG_JPEG_QUANT_T0_38             ,0x40},   // Reg   54c
      {REG_JPEG_QUANT_T0_39             ,0x44},   // Reg   54e
      {REG_JPEG_QUANT_T0_40             ,0x57},   // Reg   550
      {REG_JPEG_QUANT_T0_41             ,0x45},   // Reg   552
      {REG_JPEG_QUANT_T0_42             ,0x37},   // Reg   554
      {REG_JPEG_QUANT_T0_43             ,0x38},   // Reg   556
      {REG_JPEG_QUANT_T0_44             ,0x50},   // Reg   558
      {REG_JPEG_QUANT_T0_45             ,0x6d},   // Reg   55a
      {REG_JPEG_QUANT_T0_46             ,0x51},   // Reg   55c
      {REG_JPEG_QUANT_T0_47             ,0x57},   // Reg   55e
      {REG_JPEG_QUANT_T0_48             ,0x5f},   // Reg   560
      {REG_JPEG_QUANT_T0_49             ,0x62},   // Reg   562
      {REG_JPEG_QUANT_T0_50             ,0x67},   // Reg   564
      {REG_JPEG_QUANT_T0_51             ,0x68},   // Reg   566
      {REG_JPEG_QUANT_T0_52             ,0x67},   // Reg   568
      {REG_JPEG_QUANT_T0_53             ,0x3e},   // Reg   56a
      {REG_JPEG_QUANT_T0_54             ,0x4d},   // Reg   56c
      {REG_JPEG_QUANT_T0_55             ,0x71},   // Reg   56e
      {REG_JPEG_QUANT_T0_56             ,0x79},   // Reg   570
      {REG_JPEG_QUANT_T0_57             ,0x70},   // Reg   572
      {REG_JPEG_QUANT_T0_58             ,0x64},   // Reg   574
      {REG_JPEG_QUANT_T0_59             ,0x78},   // Reg   576
      {REG_JPEG_QUANT_T0_60             ,0x5c},   // Reg   578
      {REG_JPEG_QUANT_T0_61             ,0x65},   // Reg   57a
      {REG_JPEG_QUANT_T0_62             ,0x67},   // Reg   57c
      {REG_JPEG_QUANT_T0_63             ,0x63},   // Reg   57e

      //64 elements for Quantization table
      {REG_JPEG_QUANT_T1_00             ,0x11},   // Reg   580
      {REG_JPEG_QUANT_T1_01             ,0x12},   // Reg   582
      {REG_JPEG_QUANT_T1_02             ,0x12},   // Reg   584
      {REG_JPEG_QUANT_T1_03             ,0x18},   // Reg   586
      {REG_JPEG_QUANT_T1_04             ,0x15},   // Reg   588
      {REG_JPEG_QUANT_T1_05             ,0x18},   // Reg   58a
      {REG_JPEG_QUANT_T1_06             ,0x2f},   // Reg   58c
      {REG_JPEG_QUANT_T1_07             ,0x1a},   // Reg   58e
      {REG_JPEG_QUANT_T1_08             ,0x1a},   // Reg   590
      {REG_JPEG_QUANT_T1_09             ,0x2f},   // Reg   592
      {REG_JPEG_QUANT_T1_10             ,0x63},   // Reg   594
      {REG_JPEG_QUANT_T1_11             ,0x42},   // Reg   596
      {REG_JPEG_QUANT_T1_12             ,0x38},   // Reg   598
      {REG_JPEG_QUANT_T1_13             ,0x42},   // Reg   59a
      {REG_JPEG_QUANT_T1_14             ,0x63},   // Reg   59c
      {REG_JPEG_QUANT_T1_15             ,0x63},   // Reg   59e
      {REG_JPEG_QUANT_T1_16             ,0x63},   // Reg   5a0
      {REG_JPEG_QUANT_T1_17             ,0x63},   // Reg   5a2
      {REG_JPEG_QUANT_T1_18             ,0x63},   // Reg   5a4
      {REG_JPEG_QUANT_T1_19             ,0x63},   // Reg   5a6
      {REG_JPEG_QUANT_T1_20             ,0x63},   // Reg   5a8
      {REG_JPEG_QUANT_T1_21             ,0x63},   // Reg   5aa
      {REG_JPEG_QUANT_T1_22             ,0x63},   // Reg   5ac
      {REG_JPEG_QUANT_T1_23             ,0x63},   // Reg   5ae
      {REG_JPEG_QUANT_T1_24             ,0x63},   // Reg   5b0
      {REG_JPEG_QUANT_T1_25             ,0x63},   // Reg   5b2
      {REG_JPEG_QUANT_T1_26             ,0x63},   // Reg   5b4
      {REG_JPEG_QUANT_T1_27             ,0x63},   // Reg   5b6
      {REG_JPEG_QUANT_T1_28             ,0x63},   // Reg   5b8
      {REG_JPEG_QUANT_T1_29             ,0x63},   // Reg   5ba
      {REG_JPEG_QUANT_T1_30             ,0x63},   // Reg   5bc
      {REG_JPEG_QUANT_T1_31             ,0x63},   // Reg   5be
      {REG_JPEG_QUANT_T1_32             ,0x63},   // Reg   5c0
      {REG_JPEG_QUANT_T1_33             ,0x63},   // Reg   5c2
      {REG_JPEG_QUANT_T1_34             ,0x63},   // Reg   5c4
      {REG_JPEG_QUANT_T1_35             ,0x63},   // Reg   5c6
      {REG_JPEG_QUANT_T1_36             ,0x63},   // Reg   5c8
      {REG_JPEG_QUANT_T1_37             ,0x63},   // Reg   5ca
      {REG_JPEG_QUANT_T1_38             ,0x63},   // Reg   5cc
      {REG_JPEG_QUANT_T1_39             ,0x63},   // Reg   5ce
      {REG_JPEG_QUANT_T1_40             ,0x63},   // Reg   5d0
      {REG_JPEG_QUANT_T1_41             ,0x63},   // Reg   5d2
      {REG_JPEG_QUANT_T1_42             ,0x63},   // Reg   5d4
      {REG_JPEG_QUANT_T1_43             ,0x63},   // Reg   5d6
      {REG_JPEG_QUANT_T1_44             ,0x63},   // Reg   5d8
      {REG_JPEG_QUANT_T1_45             ,0x63},   // Reg   5da
      {REG_JPEG_QUANT_T1_46             ,0x63},   // Reg   5dc
      {REG_JPEG_QUANT_T1_47             ,0x63},   // Reg   5de
      {REG_JPEG_QUANT_T1_48             ,0x63},   // Reg   5e0
      {REG_JPEG_QUANT_T1_49             ,0x63},   // Reg   5e2
      {REG_JPEG_QUANT_T1_50             ,0x63},   // Reg   5e4
      {REG_JPEG_QUANT_T1_51             ,0x63},   // Reg   5e6
      {REG_JPEG_QUANT_T1_52             ,0x63},   // Reg   5e8
      {REG_JPEG_QUANT_T1_53             ,0x63},   // Reg   5ea
      {REG_JPEG_QUANT_T1_54             ,0x63},   // Reg   5ec
      {REG_JPEG_QUANT_T1_55             ,0x63},   // Reg   5ee
      {REG_JPEG_QUANT_T1_56             ,0x63},   // Reg   5f0
      {REG_JPEG_QUANT_T1_57             ,0x63},   // Reg   5f2
      {REG_JPEG_QUANT_T1_58             ,0x63},   // Reg   5f4
      {REG_JPEG_QUANT_T1_59             ,0x63},   // Reg   5f6
      {REG_JPEG_QUANT_T1_60             ,0x63},   // Reg   5f8
      {REG_JPEG_QUANT_T1_61             ,0x63},   // Reg   5fa
      {REG_JPEG_QUANT_T1_62             ,0x63},   // Reg   5fc
      {REG_JPEG_QUANT_T1_63             ,0x63},   // Reg   5fe

      {REG_JPEG_DC_T0_R0_00             ,0x00},   // Reg   600
      {REG_JPEG_DC_T0_R0_01             ,0x01},   // Reg   602
      {REG_JPEG_DC_T0_R0_02             ,0x05},   // Reg   604
      {REG_JPEG_DC_T0_R0_03             ,0x01},   // Reg   606
      {REG_JPEG_DC_T0_R0_04             ,0x01},   // Reg   608
      {REG_JPEG_DC_T0_R0_05             ,0x01},   // Reg   60a
      {REG_JPEG_DC_T0_R0_06             ,0x01},   // Reg   60c
      {REG_JPEG_DC_T0_R0_07             ,0x01},   // Reg   60e
      {REG_JPEG_DC_T0_R0_08             ,0x01},   // Reg   610
      {REG_JPEG_DC_T0_R0_09             ,0x00},   // Reg   612
      {REG_JPEG_DC_T0_R0_10             ,0x00},   // Reg   614
      {REG_JPEG_DC_T0_R0_11             ,0x00},   // Reg   616
      {REG_JPEG_DC_T0_R0_12             ,0x00},   // Reg   618
      {REG_JPEG_DC_T0_R0_13             ,0x00},   // Reg   61a
      {REG_JPEG_DC_T0_R0_14             ,0x00},   // Reg   61c
      {REG_JPEG_DC_T0_R0_15             ,0x00},   // Reg   61e

      {REG_JPEG_DC_T0_R1_00             ,0x00},   // Reg   620
      {REG_JPEG_DC_T0_R1_01             ,0x01},   // Reg   622
      {REG_JPEG_DC_T0_R1_02             ,0x02},   // Reg   624
      {REG_JPEG_DC_T0_R1_03             ,0x03},   // Reg   626
      {REG_JPEG_DC_T0_R1_04             ,0x04},   // Reg   628
      {REG_JPEG_DC_T0_R1_05             ,0x05},   // Reg   62a
      {REG_JPEG_DC_T0_R1_06             ,0x06},   // Reg   62c
      {REG_JPEG_DC_T0_R1_07             ,0x07},   // Reg   62e
      {REG_JPEG_DC_T0_R1_08             ,0x08},   // Reg   630
      {REG_JPEG_DC_T0_R1_09             ,0x09},   // Reg   632
      {REG_JPEG_DC_T0_R1_10             ,0x0a},   // Reg   634
      {REG_JPEG_DC_T0_R1_11             ,0x0b},   // Reg   636

      {REG_JPEG_AC_T0_R0_00             ,0x00},   // Reg   640
      {REG_JPEG_AC_T0_R0_01             ,0x02},   // Reg   642
      {REG_JPEG_AC_T0_R0_02             ,0x01},   // Reg   644
      {REG_JPEG_AC_T0_R0_03             ,0x03},   // Reg   646
      {REG_JPEG_AC_T0_R0_04             ,0x03},   // Reg   648
      {REG_JPEG_AC_T0_R0_05             ,0x02},   // Reg   64a
      {REG_JPEG_AC_T0_R0_06             ,0x04},   // Reg   64c
      {REG_JPEG_AC_T0_R0_07             ,0x03},   // Reg   64e
      {REG_JPEG_AC_T0_R0_08             ,0x05},   // Reg   650
      {REG_JPEG_AC_T0_R0_09             ,0x05},   // Reg   652
      {REG_JPEG_AC_T0_R0_10             ,0x04},   // Reg   654
      {REG_JPEG_AC_T0_R0_11             ,0x04},   // Reg   656
      {REG_JPEG_AC_T0_R0_12             ,0x00},   // Reg   658
      {REG_JPEG_AC_T0_R0_13             ,0x00},   // Reg   65a
      {REG_JPEG_AC_T0_R0_14             ,0x01},   // Reg   65c
      {REG_JPEG_AC_T0_R0_15             ,0x7d},   // Reg   65e

      {REG_JPEG_AC_T0_R1_00             ,0x01},   // Reg   660
      {REG_JPEG_AC_T0_R1_01             ,0x02},   // Reg   662
      {REG_JPEG_AC_T0_R1_02             ,0x03},   // Reg   664
      {REG_JPEG_AC_T0_R1_03             ,0x00},   // Reg   666
      {REG_JPEG_AC_T0_R1_04             ,0x04},   // Reg   668
      {REG_JPEG_AC_T0_R1_05             ,0x11},   // Reg   66a
      {REG_JPEG_AC_T0_R1_06             ,0x05},   // Reg   66c
      {REG_JPEG_AC_T0_R1_07             ,0x12},   // Reg   66e
      {REG_JPEG_AC_T0_R1_08             ,0x21},   // Reg   670
      {REG_JPEG_AC_T0_R1_09             ,0x31},   // Reg   672
      {REG_JPEG_AC_T0_R1_10             ,0x41},   // Reg   674
      {REG_JPEG_AC_T0_R1_11             ,0x06},   // Reg   676
      {REG_JPEG_AC_T0_R1_12             ,0x13},   // Reg   678
      {REG_JPEG_AC_T0_R1_13             ,0x51},   // Reg   67a
      {REG_JPEG_AC_T0_R1_14             ,0x61},   // Reg   67c
      {REG_JPEG_AC_T0_R1_15             ,0x07},   // Reg   67e
      {REG_JPEG_AC_T0_R1_16             ,0x22},   // Reg   680
      {REG_JPEG_AC_T0_R1_17             ,0x71},   // Reg   682
      {REG_JPEG_AC_T0_R1_18             ,0x14},   // Reg   684
      {REG_JPEG_AC_T0_R1_19             ,0x32},   // Reg   686
      {REG_JPEG_AC_T0_R1_20             ,0x81},   // Reg   688
      {REG_JPEG_AC_T0_R1_21             ,0x91},   // Reg   68a
      {REG_JPEG_AC_T0_R1_22             ,0xa1},   // Reg   68c
      {REG_JPEG_AC_T0_R1_23             ,0x08},   // Reg   68e
      {REG_JPEG_AC_T0_R1_24             ,0x23},   // Reg   690
      {REG_JPEG_AC_T0_R1_25             ,0x42},   // Reg   692
      {REG_JPEG_AC_T0_R1_26             ,0xb1},   // Reg   694
      {REG_JPEG_AC_T0_R1_27             ,0xc1},   // Reg   696
      {REG_JPEG_AC_T0_R1_28             ,0x15},   // Reg   698
      {REG_JPEG_AC_T0_R1_29             ,0x52},   // Reg   69a
      {REG_JPEG_AC_T0_R1_30             ,0xd1},   // Reg   69c
      {REG_JPEG_AC_T0_R1_31             ,0xf0},   // Reg   69e
      {REG_JPEG_AC_T0_R1_32             ,0x24},   // Reg   6a0
      {REG_JPEG_AC_T0_R1_33             ,0x33},   // Reg   6a2
      {REG_JPEG_AC_T0_R1_34             ,0x62},   // Reg   6a4
      {REG_JPEG_AC_T0_R1_35             ,0x72},   // Reg   6a6
      {REG_JPEG_AC_T0_R1_36             ,0x82},   // Reg   6a8
      {REG_JPEG_AC_T0_R1_37             ,0x09},   // Reg   6aa
      {REG_JPEG_AC_T0_R1_38             ,0x0a},   // Reg   6ac
      {REG_JPEG_AC_T0_R1_39             ,0x16},   // Reg   6ae
      {REG_JPEG_AC_T0_R1_40             ,0x17},   // Reg   6b0
      {REG_JPEG_AC_T0_R1_41             ,0x18},   // Reg   6b2
      {REG_JPEG_AC_T0_R1_42             ,0x19},   // Reg   6b4
      {REG_JPEG_AC_T0_R1_43             ,0x1a},   // Reg   6b6
      {REG_JPEG_AC_T0_R1_44             ,0x25},   // Reg   6b8
      {REG_JPEG_AC_T0_R1_45             ,0x26},   // Reg   6ba
      {REG_JPEG_AC_T0_R1_46             ,0x27},   // Reg   6bc
      {REG_JPEG_AC_T0_R1_47             ,0x28},   // Reg   6be
      {REG_JPEG_AC_T0_R1_48             ,0x29},   // Reg   6c0
      {REG_JPEG_AC_T0_R1_49             ,0x2a},   // Reg   6c2
      {REG_JPEG_AC_T0_R1_50             ,0x34},   // Reg   6c4
      {REG_JPEG_AC_T0_R1_51             ,0x35},   // Reg   6c6
      {REG_JPEG_AC_T0_R1_52             ,0x36},   // Reg   6c8
      {REG_JPEG_AC_T0_R1_53             ,0x37},   // Reg   6ca
      {REG_JPEG_AC_T0_R1_54             ,0x38},   // Reg   6cc
      {REG_JPEG_AC_T0_R1_55             ,0x39},   // Reg   6ce
      {REG_JPEG_AC_T0_R1_56             ,0x3a},   // Reg   6d0
      {REG_JPEG_AC_T0_R1_57             ,0x43},   // Reg   6d2
      {REG_JPEG_AC_T0_R1_58             ,0x44},   // Reg   6d4
      {REG_JPEG_AC_T0_R1_59             ,0x45},   // Reg   6d6
      {REG_JPEG_AC_T0_R1_60             ,0x46},   // Reg   6d8
      {REG_JPEG_AC_T0_R1_61             ,0x47},   // Reg   6da
      {REG_JPEG_AC_T0_R1_62             ,0x48},   // Reg   6dc
      {REG_JPEG_AC_T0_R1_63             ,0x49},   // Reg   6de
      {REG_JPEG_AC_T0_R1_64             ,0x4a},   // Reg   6e0
      {REG_JPEG_AC_T0_R1_65             ,0x53},   // Reg   6e2
      {REG_JPEG_AC_T0_R1_66             ,0x54},   // Reg   6e4
      {REG_JPEG_AC_T0_R1_67             ,0x55},   // Reg   6e6
      {REG_JPEG_AC_T0_R1_68             ,0x56},   // Reg   6e8
      {REG_JPEG_AC_T0_R1_69             ,0x57},   // Reg   6ea
      {REG_JPEG_AC_T0_R1_70             ,0x58},   // Reg   6ec
      {REG_JPEG_AC_T0_R1_71             ,0x59},   // Reg   6ee
      {REG_JPEG_AC_T0_R1_72             ,0x5a},   // Reg   6f0
      {REG_JPEG_AC_T0_R1_73             ,0x63},   // Reg   6f2
      {REG_JPEG_AC_T0_R1_74             ,0x64},   // Reg   6f4
      {REG_JPEG_AC_T0_R1_75             ,0x65},   // Reg   6f6
      {REG_JPEG_AC_T0_R1_76             ,0x66},   // Reg   6f8
      {REG_JPEG_AC_T0_R1_77             ,0x67},   // Reg   6fa
      {REG_JPEG_AC_T0_R1_78             ,0x68},   // Reg   6fc
      {REG_JPEG_AC_T0_R1_79             ,0x69},   // Reg   6fe
      {REG_JPEG_AC_T0_R1_80             ,0x6a},   // Reg   700
      {REG_JPEG_AC_T0_R1_81             ,0x73},   // Reg   702
      {REG_JPEG_AC_T0_R1_82             ,0x74},   // Reg   704
      {REG_JPEG_AC_T0_R1_83             ,0x75},   // Reg   706
      {REG_JPEG_AC_T0_R1_84             ,0x76},   // Reg   708
      {REG_JPEG_AC_T0_R1_85             ,0x77},   // Reg   70a
      {REG_JPEG_AC_T0_R1_86             ,0x78},   // Reg   70c
      {REG_JPEG_AC_T0_R1_87             ,0x79},   // Reg   70e
      {REG_JPEG_AC_T0_R1_88             ,0x7a},   // Reg   710
      {REG_JPEG_AC_T0_R1_89             ,0x83},   // Reg   712
      {REG_JPEG_AC_T0_R1_90             ,0x84},   // Reg   714
      {REG_JPEG_AC_T0_R1_91             ,0x85},   // Reg   716
      {REG_JPEG_AC_T0_R1_92             ,0x86},   // Reg   718
      {REG_JPEG_AC_T0_R1_93             ,0x87},   // Reg   71a
      {REG_JPEG_AC_T0_R1_94             ,0x88},   // Reg   71c
      {REG_JPEG_AC_T0_R1_95             ,0x89},   // Reg   71e
      {REG_JPEG_AC_T0_R1_96             ,0x8a},   // Reg   720
      {REG_JPEG_AC_T0_R1_97             ,0x92},   // Reg   722
      {REG_JPEG_AC_T0_R1_98             ,0x93},   // Reg   724
      {REG_JPEG_AC_T0_R1_99             ,0x94},   // Reg   726
      {REG_JPEG_AC_T0_R1_100            ,0x95},   // Reg   728
      {REG_JPEG_AC_T0_R1_101            ,0x96},   // Reg   72a
      {REG_JPEG_AC_T0_R1_102            ,0x97},   // Reg   72c
      {REG_JPEG_AC_T0_R1_103            ,0x98},   // Reg   72e
      {REG_JPEG_AC_T0_R1_104            ,0x99},   // Reg   730
      {REG_JPEG_AC_T0_R1_105            ,0x9a},   // Reg   732
      {REG_JPEG_AC_T0_R1_106            ,0xa2},   // Reg   734
      {REG_JPEG_AC_T0_R1_107            ,0xa3},   // Reg   736
      {REG_JPEG_AC_T0_R1_108            ,0xa4},   // Reg   738
      {REG_JPEG_AC_T0_R1_109            ,0xa5},   // Reg   73a
      {REG_JPEG_AC_T0_R1_110            ,0xa6},   // Reg   73c
      {REG_JPEG_AC_T0_R1_111            ,0xa7},   // Reg   73e
      {REG_JPEG_AC_T0_R1_112            ,0xa8},   // Reg   740
      {REG_JPEG_AC_T0_R1_113            ,0xa9},   // Reg   742
      {REG_JPEG_AC_T0_R1_114            ,0xaa},   // Reg   744
      {REG_JPEG_AC_T0_R1_115            ,0xb2},   // Reg   746
      {REG_JPEG_AC_T0_R1_116            ,0xb3},   // Reg   748
      {REG_JPEG_AC_T0_R1_117            ,0xb4},   // Reg   74a
      {REG_JPEG_AC_T0_R1_118            ,0xb5},   // Reg   74c
      {REG_JPEG_AC_T0_R1_119            ,0xb6},   // Reg   75e
      {REG_JPEG_AC_T0_R1_120            ,0xb7},   // Reg   750
      {REG_JPEG_AC_T0_R1_121            ,0xb8},   // Reg   752
      {REG_JPEG_AC_T0_R1_122            ,0xb9},   // Reg   754
      {REG_JPEG_AC_T0_R1_123            ,0xba},   // Reg   756
      {REG_JPEG_AC_T0_R1_124            ,0xc2},   // Reg   758
      {REG_JPEG_AC_T0_R1_125            ,0xc3},   // Reg   75a
      {REG_JPEG_AC_T0_R1_126            ,0xc4},   // Reg   75c
      {REG_JPEG_AC_T0_R1_127            ,0xc5},   // Reg   75e
      {REG_JPEG_AC_T0_R1_128            ,0xc6},   // Reg   760
      {REG_JPEG_AC_T0_R1_129            ,0xc7},   // Reg   762
      {REG_JPEG_AC_T0_R1_130            ,0xc8},   // Reg   764
      {REG_JPEG_AC_T0_R1_131            ,0xc9},   // Reg   766
      {REG_JPEG_AC_T0_R1_132            ,0xca},   // Reg   768
      {REG_JPEG_AC_T0_R1_133            ,0xd2},   // Reg   76a
      {REG_JPEG_AC_T0_R1_134            ,0xd3},   // Reg   76c
      {REG_JPEG_AC_T0_R1_135            ,0xd4},   // Reg   76e
      {REG_JPEG_AC_T0_R1_136            ,0xd5},   // Reg   770
      {REG_JPEG_AC_T0_R1_137            ,0xd6},   // Reg   772
      {REG_JPEG_AC_T0_R1_138            ,0xd7},   // Reg   774
      {REG_JPEG_AC_T0_R1_139            ,0xd8},   // Reg   776
      {REG_JPEG_AC_T0_R1_140            ,0xd9},   // Reg   778
      {REG_JPEG_AC_T0_R1_141            ,0xda},   // Reg   77a
      {REG_JPEG_AC_T0_R1_142            ,0xe1},   // Reg   77c
      {REG_JPEG_AC_T0_R1_143            ,0xe2},   // Reg   77e
      {REG_JPEG_AC_T0_R1_144            ,0xe3},   // Reg   780
      {REG_JPEG_AC_T0_R1_145            ,0xe4},   // Reg   782
      {REG_JPEG_AC_T0_R1_146            ,0xe5},   // Reg   784
      {REG_JPEG_AC_T0_R1_147            ,0xe6},   // Reg   786
      {REG_JPEG_AC_T0_R1_148            ,0xe7},   // Reg   788
      {REG_JPEG_AC_T0_R1_149            ,0xe8},   // Reg   78a
      {REG_JPEG_AC_T0_R1_150            ,0xe9},   // Reg   78c
      {REG_JPEG_AC_T0_R1_151            ,0xea},   // Reg   78e
      {REG_JPEG_AC_T0_R1_152            ,0xf1},   // Reg   790
      {REG_JPEG_AC_T0_R1_153            ,0xf2},   // Reg   792
      {REG_JPEG_AC_T0_R1_154            ,0xf3},   // Reg   794
      {REG_JPEG_AC_T0_R1_155            ,0xf4},   // Reg   796
      {REG_JPEG_AC_T0_R1_156            ,0xf5},   // Reg   798
      {REG_JPEG_AC_T0_R1_157            ,0xf6},   // Reg   79a
      {REG_JPEG_AC_T0_R1_158            ,0xf7},   // Reg   79c
      {REG_JPEG_AC_T0_R1_159            ,0xf8},   // Reg   79e
      {REG_JPEG_AC_T0_R1_160            ,0xf9},   // Reg   7a0
      {REG_JPEG_AC_T0_R1_161            ,0xfa},   // Reg   7a2

      {REG_JPEG_DC_T1_R0_00             ,0x00},   // Reg   800
      {REG_JPEG_DC_T1_R0_01             ,0x03},   // Reg   802
      {REG_JPEG_DC_T1_R0_02             ,0x01},   // Reg   804
      {REG_JPEG_DC_T1_R0_03             ,0x01},   // Reg   806
      {REG_JPEG_DC_T1_R0_04             ,0x01},   // Reg   808
      {REG_JPEG_DC_T1_R0_05             ,0x01},   // Reg   80a
      {REG_JPEG_DC_T1_R0_06             ,0x01},   // Reg   80c
      {REG_JPEG_DC_T1_R0_07             ,0x01},   // Reg   80e
      {REG_JPEG_DC_T1_R0_08             ,0x01},   // Reg   810
      {REG_JPEG_DC_T1_R0_09             ,0x01},   // Reg   812
      {REG_JPEG_DC_T1_R0_10             ,0x01},   // Reg   814
      {REG_JPEG_DC_T1_R0_11             ,0x00},   // Reg   816
      {REG_JPEG_DC_T1_R0_12             ,0x00},   // Reg   818
      {REG_JPEG_DC_T1_R0_13             ,0x00},   // Reg   81a
      {REG_JPEG_DC_T1_R0_14             ,0x00},   // Reg   81c
      {REG_JPEG_DC_T1_R0_15             ,0x00},   // Reg   81e

      {REG_JPEG_DC_T1_R1_00             ,0x00},   // Reg   820
      {REG_JPEG_DC_T1_R1_01             ,0x01},   // Reg   822
      {REG_JPEG_DC_T1_R1_02             ,0x02},   // Reg   824
      {REG_JPEG_DC_T1_R1_03             ,0x03},   // Reg   826
      {REG_JPEG_DC_T1_R1_04             ,0x04},   // Reg   828
      {REG_JPEG_DC_T1_R1_05             ,0x05},   // Reg   82a
      {REG_JPEG_DC_T1_R1_06             ,0x06},   // Reg   82c
      {REG_JPEG_DC_T1_R1_07             ,0x07},   // Reg   82e
      {REG_JPEG_DC_T1_R1_08             ,0x08},   // Reg   830
      {REG_JPEG_DC_T1_R1_09             ,0x09},   // Reg   832
      {REG_JPEG_DC_T1_R1_10             ,0x0a},   // Reg   834
      {REG_JPEG_DC_T1_R1_11             ,0x0b},   // Reg   836

      {REG_JPEG_AC_T1_R0_00             ,0x00},   // Reg   840
      {REG_JPEG_AC_T1_R0_01             ,0x02},   // Reg   842
      {REG_JPEG_AC_T1_R0_02             ,0x01},   // Reg   844
      {REG_JPEG_AC_T1_R0_03             ,0x02},   // Reg   846
      {REG_JPEG_AC_T1_R0_04             ,0x04},   // Reg   848
      {REG_JPEG_AC_T1_R0_05             ,0x04},   // Reg   84a
      {REG_JPEG_AC_T1_R0_06             ,0x03},   // Reg   84c
      {REG_JPEG_AC_T1_R0_07             ,0x04},   // Reg   84e
      {REG_JPEG_AC_T1_R0_08             ,0x07},   // Reg   850
      {REG_JPEG_AC_T1_R0_09             ,0x05},   // Reg   852
      {REG_JPEG_AC_T1_R0_10             ,0x04},   // Reg   854
      {REG_JPEG_AC_T1_R0_11             ,0x04},   // Reg   856
      {REG_JPEG_AC_T1_R0_12             ,0x00},   // Reg   858
      {REG_JPEG_AC_T1_R0_13             ,0x01},   // Reg   85a
      {REG_JPEG_AC_T1_R0_14             ,0x02},   // Reg   85c
      {REG_JPEG_AC_T1_R0_15             ,0x77},   // Reg   85e

      {REG_JPEG_AC_T1_R1_00             ,0x00},   // Reg   860
      {REG_JPEG_AC_T1_R1_01             ,0x01},   // Reg   862
      {REG_JPEG_AC_T1_R1_02             ,0x02},   // Reg   864
      {REG_JPEG_AC_T1_R1_03             ,0x03},   // Reg   866
      {REG_JPEG_AC_T1_R1_04             ,0x11},   // Reg   868
      {REG_JPEG_AC_T1_R1_05             ,0x04},   // Reg   86a
      {REG_JPEG_AC_T1_R1_06             ,0x05},   // Reg   86c
      {REG_JPEG_AC_T1_R1_07             ,0x21},   // Reg   86e
      {REG_JPEG_AC_T1_R1_08             ,0x31},   // Reg   870
      {REG_JPEG_AC_T1_R1_09             ,0x06},   // Reg   872
      {REG_JPEG_AC_T1_R1_10             ,0x12},   // Reg   874
      {REG_JPEG_AC_T1_R1_11             ,0x41},   // Reg   876
      {REG_JPEG_AC_T1_R1_12             ,0x51},   // Reg   878
      {REG_JPEG_AC_T1_R1_13             ,0x07},   // Reg   87a
      {REG_JPEG_AC_T1_R1_14             ,0x61},   // Reg   87c
      {REG_JPEG_AC_T1_R1_15             ,0x71},   // Reg   87e
      {REG_JPEG_AC_T1_R1_16             ,0x13},   // Reg   880
      {REG_JPEG_AC_T1_R1_17             ,0x22},   // Reg   882
      {REG_JPEG_AC_T1_R1_18             ,0x32},   // Reg   884
      {REG_JPEG_AC_T1_R1_19             ,0x81},   // Reg   886
      {REG_JPEG_AC_T1_R1_20             ,0x08},   // Reg   888
      {REG_JPEG_AC_T1_R1_21             ,0x14},   // Reg   88a
      {REG_JPEG_AC_T1_R1_22             ,0x42},   // Reg   88c
      {REG_JPEG_AC_T1_R1_23             ,0x91},   // Reg   88e
      {REG_JPEG_AC_T1_R1_24             ,0xa1},   // Reg   890
      {REG_JPEG_AC_T1_R1_25             ,0xb1},   // Reg   892
      {REG_JPEG_AC_T1_R1_26             ,0xc1},   // Reg   894
      {REG_JPEG_AC_T1_R1_27             ,0x09},   // Reg   896
      {REG_JPEG_AC_T1_R1_28             ,0x23},   // Reg   898
      {REG_JPEG_AC_T1_R1_29             ,0x33},   // Reg   89a
      {REG_JPEG_AC_T1_R1_30             ,0x52},   // Reg   89c
      {REG_JPEG_AC_T1_R1_31             ,0xf0},   // Reg   89e
      {REG_JPEG_AC_T1_R1_32             ,0x15},   // Reg   8a0
      {REG_JPEG_AC_T1_R1_33             ,0x62},   // Reg   8a2
      {REG_JPEG_AC_T1_R1_34             ,0x72},   // Reg   8a4
      {REG_JPEG_AC_T1_R1_35             ,0xd1},   // Reg   8a6
      {REG_JPEG_AC_T1_R1_36             ,0x0a},   // Reg   8a8
      {REG_JPEG_AC_T1_R1_37             ,0x16},   // Reg   8aa
      {REG_JPEG_AC_T1_R1_38             ,0x24},   // Reg   8ac
      {REG_JPEG_AC_T1_R1_39             ,0x34},   // Reg   8ae
      {REG_JPEG_AC_T1_R1_40             ,0xe1},   // Reg   8b0
      {REG_JPEG_AC_T1_R1_41             ,0x25},   // Reg   8b2
      {REG_JPEG_AC_T1_R1_42             ,0xf1},   // Reg   8b4
      {REG_JPEG_AC_T1_R1_43             ,0x17},   // Reg   8b6
      {REG_JPEG_AC_T1_R1_44             ,0x18},   // Reg   8b8
      {REG_JPEG_AC_T1_R1_45             ,0x19},   // Reg   8ba
      {REG_JPEG_AC_T1_R1_46             ,0x1a},   // Reg   8bc
      {REG_JPEG_AC_T1_R1_47             ,0x26},   // Reg   8be
      {REG_JPEG_AC_T1_R1_48             ,0x27},   // Reg   8c0
      {REG_JPEG_AC_T1_R1_49             ,0x28},   // Reg   8c2
      {REG_JPEG_AC_T1_R1_50             ,0x29},   // Reg   8c4
      {REG_JPEG_AC_T1_R1_51             ,0x2a},   // Reg   8c6
      {REG_JPEG_AC_T1_R1_52             ,0x35},   // Reg   8c8
      {REG_JPEG_AC_T1_R1_53             ,0x36},   // Reg   8ca
      {REG_JPEG_AC_T1_R1_54             ,0x37},   // Reg   8cc
      {REG_JPEG_AC_T1_R1_55             ,0x38},   // Reg   8ce
      {REG_JPEG_AC_T1_R1_56             ,0x39},   // Reg   8d0
      {REG_JPEG_AC_T1_R1_57             ,0x3a},   // Reg   8d2
      {REG_JPEG_AC_T1_R1_58             ,0x43},   // Reg   8d4
      {REG_JPEG_AC_T1_R1_59             ,0x44},   // Reg   8d6
      {REG_JPEG_AC_T1_R1_60             ,0x45},   // Reg   8d8
      {REG_JPEG_AC_T1_R1_61             ,0x46},   // Reg   8da
      {REG_JPEG_AC_T1_R1_62             ,0x47},   // Reg   8dc
      {REG_JPEG_AC_T1_R1_63             ,0x48},   // Reg   8de
      {REG_JPEG_AC_T1_R1_64             ,0x49},   // Reg   8e0
      {REG_JPEG_AC_T1_R1_65             ,0x4a},   // Reg   8e2
      {REG_JPEG_AC_T1_R1_66             ,0x53},   // Reg   8e4
      {REG_JPEG_AC_T1_R1_67             ,0x54},   // Reg   8e6
      {REG_JPEG_AC_T1_R1_68             ,0x55},   // Reg   8e8
      {REG_JPEG_AC_T1_R1_69             ,0x56},   // Reg   8ea
      {REG_JPEG_AC_T1_R1_70             ,0x57},   // Reg   8ec
      {REG_JPEG_AC_T1_R1_71             ,0x58},   // Reg   8ee
      {REG_JPEG_AC_T1_R1_72             ,0x59},   // Reg   8f0
      {REG_JPEG_AC_T1_R1_73             ,0x5a},   // Reg   8f2
      {REG_JPEG_AC_T1_R1_74             ,0x63},   // Reg   8f4
      {REG_JPEG_AC_T1_R1_75             ,0x64},   // Reg   8f6
      {REG_JPEG_AC_T1_R1_76             ,0x65},   // Reg   8f8
      {REG_JPEG_AC_T1_R1_77             ,0x66},   // Reg   8fa
      {REG_JPEG_AC_T1_R1_78             ,0x67},   // Reg   8fc
      {REG_JPEG_AC_T1_R1_79             ,0x68},   // Reg   8fe
      {REG_JPEG_AC_T1_R1_80             ,0x69},   // Reg   900
      {REG_JPEG_AC_T1_R1_81             ,0x6a},   // Reg   902
      {REG_JPEG_AC_T1_R1_82             ,0x73},   // Reg   904
      {REG_JPEG_AC_T1_R1_83             ,0x74},   // Reg   906
      {REG_JPEG_AC_T1_R1_84             ,0x75},   // Reg   908
      {REG_JPEG_AC_T1_R1_85             ,0x76},   // Reg   90a
      {REG_JPEG_AC_T1_R1_86             ,0x77},   // Reg   90c
      {REG_JPEG_AC_T1_R1_87             ,0x78},   // Reg   90e
      {REG_JPEG_AC_T1_R1_88             ,0x79},   // Reg   910
      {REG_JPEG_AC_T1_R1_89             ,0x7a},   // Reg   912
      {REG_JPEG_AC_T1_R1_90             ,0x82},   // Reg   914
      {REG_JPEG_AC_T1_R1_91             ,0x83},   // Reg   916
      {REG_JPEG_AC_T1_R1_92             ,0x84},   // Reg   918
      {REG_JPEG_AC_T1_R1_93             ,0x85},   // Reg   91a
      {REG_JPEG_AC_T1_R1_94             ,0x86},   // Reg   91c
      {REG_JPEG_AC_T1_R1_95             ,0x87},   // Reg   91e
      {REG_JPEG_AC_T1_R1_96             ,0x88},   // Reg   920
      {REG_JPEG_AC_T1_R1_97             ,0x89},   // Reg   922
      {REG_JPEG_AC_T1_R1_98             ,0x8a},   // Reg   924
      {REG_JPEG_AC_T1_R1_99             ,0x92},   // Reg   926
      {REG_JPEG_AC_T1_R1_100            ,0x93},   // Reg   928
      {REG_JPEG_AC_T1_R1_101            ,0x94},   // Reg   92a
      {REG_JPEG_AC_T1_R1_102            ,0x95},   // Reg   92c
      {REG_JPEG_AC_T1_R1_103            ,0x96},   // Reg   92e
      {REG_JPEG_AC_T1_R1_104            ,0x97},   // Reg   930
      {REG_JPEG_AC_T1_R1_105            ,0x98},   // Reg   932
      {REG_JPEG_AC_T1_R1_106            ,0x99},   // Reg   934
      {REG_JPEG_AC_T1_R1_107            ,0x9a},   // Reg   936
      {REG_JPEG_AC_T1_R1_108            ,0xa2},   // Reg   938
      {REG_JPEG_AC_T1_R1_109            ,0xa3},   // Reg   93a
      {REG_JPEG_AC_T1_R1_110            ,0xa4},   // Reg   93c
      {REG_JPEG_AC_T1_R1_111            ,0xa5},   // Reg   93e
      {REG_JPEG_AC_T1_R1_112            ,0xa6},   // Reg   940
      {REG_JPEG_AC_T1_R1_113            ,0xa7},   // Reg   942
      {REG_JPEG_AC_T1_R1_114            ,0xa8},   // Reg   944
      {REG_JPEG_AC_T1_R1_115            ,0xa9},   // Reg   946
      {REG_JPEG_AC_T1_R1_116            ,0xaa},   // Reg   948
      {REG_JPEG_AC_T1_R1_117            ,0xb2},   // Reg   94a
      {REG_JPEG_AC_T1_R1_118            ,0xb3},   // Reg   94c
      {REG_JPEG_AC_T1_R1_119            ,0xb4},   // Reg   95e
      {REG_JPEG_AC_T1_R1_120            ,0xb5},   // Reg   950
      {REG_JPEG_AC_T1_R1_121            ,0xb6},   // Reg   952
      {REG_JPEG_AC_T1_R1_122            ,0xb7},   // Reg   954
      {REG_JPEG_AC_T1_R1_123            ,0xb8},   // Reg   956
      {REG_JPEG_AC_T1_R1_124            ,0xb9},   // Reg   958
      {REG_JPEG_AC_T1_R1_125            ,0xba},   // Reg   95a
      {REG_JPEG_AC_T1_R1_126            ,0xc2},   // Reg   95c
      {REG_JPEG_AC_T1_R1_127            ,0xc3},   // Reg   95e
      {REG_JPEG_AC_T1_R1_128            ,0xc4},   // Reg   960
      {REG_JPEG_AC_T1_R1_129            ,0xc5},   // Reg   962
      {REG_JPEG_AC_T1_R1_130            ,0xc6},   // Reg   964
      {REG_JPEG_AC_T1_R1_131            ,0xc7},   // Reg   966
      {REG_JPEG_AC_T1_R1_132            ,0xc8},   // Reg   968
      {REG_JPEG_AC_T1_R1_133            ,0xc9},   // Reg   96a
      {REG_JPEG_AC_T1_R1_134            ,0xca},   // Reg   96c
      {REG_JPEG_AC_T1_R1_135            ,0xd2},   // Reg   96e
      {REG_JPEG_AC_T1_R1_136            ,0xd3},   // Reg   970
      {REG_JPEG_AC_T1_R1_137            ,0xd4},   // Reg   972
      {REG_JPEG_AC_T1_R1_138            ,0xd5},   // Reg   974
      {REG_JPEG_AC_T1_R1_139            ,0xd6},   // Reg   976
      {REG_JPEG_AC_T1_R1_140            ,0xd7},   // Reg   978
      {REG_JPEG_AC_T1_R1_141            ,0xd8},   // Reg   97a
      {REG_JPEG_AC_T1_R1_142            ,0xd9},   // Reg   97c
      {REG_JPEG_AC_T1_R1_143            ,0xda},   // Reg   97e
      {REG_JPEG_AC_T1_R1_144            ,0xe2},   // Reg   980
      {REG_JPEG_AC_T1_R1_145            ,0xe3},   // Reg   982
      {REG_JPEG_AC_T1_R1_146            ,0xe4},   // Reg   984
      {REG_JPEG_AC_T1_R1_147            ,0xe5},   // Reg   986
      {REG_JPEG_AC_T1_R1_148            ,0xe6},   // Reg   988
      {REG_JPEG_AC_T1_R1_149            ,0xe7},   // Reg   98a
      {REG_JPEG_AC_T1_R1_150            ,0xe8},   // Reg   98c
      {REG_JPEG_AC_T1_R1_151            ,0xe9},   // Reg   98e
      {REG_JPEG_AC_T1_R1_152            ,0xea},   // Reg   990
      {REG_JPEG_AC_T1_R1_153            ,0xf2},   // Reg   992
      {REG_JPEG_AC_T1_R1_154            ,0xf3},   // Reg   994
      {REG_JPEG_AC_T1_R1_155            ,0xf4},   // Reg   996
      {REG_JPEG_AC_T1_R1_156            ,0xf5},   // Reg   998
      {REG_JPEG_AC_T1_R1_157            ,0xf6},   // Reg   99a
      {REG_JPEG_AC_T1_R1_158            ,0xf7},   // Reg   99c
      {REG_JPEG_AC_T1_R1_159            ,0xf8},   // Reg   99e
      {REG_JPEG_AC_T1_R1_160            ,0xf9},   // Reg   9a0
      {REG_JPEG_AC_T1_R1_161            ,0xfa},   // Reg   9a2

      {REG_JPEG_QTABLE_CONST_0          ,0x03},   // Reg   9b0
      {REG_JPEG_QTABLE_CONST_1          ,0x01},   // Reg   9b2
      {REG_JPEG_QTABLE_CONST_2          ,0x02},   // Reg   9b4
      {REG_JPEG_QTABLE_CONST_3          ,0x03},   // Reg   9b6

      {REG_JPEG_QTABLE0_SAMPLE          ,0x21},   // Reg   9b8
      {0x9ba                            ,0x0 },
      {REG_JPEG_QTABLE1_SAMPLE          ,0x11},   // Reg   9bc
      {0x9be                            ,0x01},
      {REG_JPEG_QTABLE2_SAMPLE          ,0x11},   // Reg   9c0
      {0x9c2                            ,0x01},

      {REG_JPEG_DRI_CONST_0             ,0xff},   // Reg   9c4
      {REG_JPEG_DRI_CONST_1             ,0xdd},   // Reg   9c6
      {REG_JPEG_DRI_CONST_2             ,0x00},   // Reg   9c8
      {REG_JPEG_DRI_CONST_3             ,0x04},   // Reg   9ca

      {REG_JPEG_SOS_CONST_0             ,0xff},   // Reg   9cc
      {REG_JPEG_SOS_CONST_1             ,0xda},   // Reg   9ce
      {REG_JPEG_SOS_CONST_2             ,0x00},   // Reg   9d0
      {REG_JPEG_SOS_CONST_3             ,0x0c},   // Reg   9d2
      {REG_JPEG_SOS_CONST_4             ,0x03},   // Reg   9d4
      {0x9d8                            ,0x01},
      {0x9da                            ,0x00},
      {0x9dc                            ,0x02},
      {0x9de                            ,0x11},
      {0x9e0                            ,0x03},
      {0x9e2                            ,0x11},

      {REG_JPEG_EOI_CONST_0             ,0x00},   // Reg   9e4
      {REG_JPEG_EOI_CONST_1             ,0x3f},   // Reg   9e6
      {REG_JPEG_EOI_CONST_2             ,0x00},   // Reg   9e8
      {REG_JPEG_EOI_CONST_3             ,0xff},   // Reg   9ea
      {REG_JPEG_EOI_CONST_4             ,0xd9},   // Reg   9ec
      {REG_DEFINE_END                   ,0x00},
    };

//By default, use maximum resolution for JPEG encoding


void ssd192x_jpeg_init(void) // set the reg_init[][2] data to register.
{
  INT32 i=0;

  myprintf("Initializing JPEG basic register\n\r");

  while(reg_init[i][0]!=REG_DEFINE_END) // REG_DEFINE_END==0xffff.
  {
    SSD_REGWB(reg_init[i][0],reg_init[i][1]);
    i++;
  }
  return;
}


void Set_JPEG_Encode_Registers(UINT32 jpeg_width,UINT32 jpeg_height)
{
	UINT32 vpixel, hpixel;
	UINT8 vpixel_8, hpixel_8;
	UINT32 exp_jpeg_width, exp_jpeg_height;
	UINT32 line_buf, vert_buf;

	UINT32 raw_jpeg_addr = 0;
	UINT32 encoded_jpeg_addr = LCD_WIDTH * LCD_HEIGHT*2;

	// count_h & v are for the decimation ratio, if 1, means divide 2 from the input of CMOS sensor
	char count_h =0;
	char count_v =0;

	exp_jpeg_width = jpeg_width;
	exp_jpeg_height = jpeg_height;

	//myprintf("lcdw = %d, lcdh = %d, jpeg_width =%d, jpeg_height =%d,SET_CAM_WIDTH =%d, SET_CAM_HEIGHT =%d\r\n",
	//		LCD_WIDTH, LCD_HEIGHT, jpeg_width, jpeg_height,SET_CAM_WIDTH, SET_CAM_HEIGHT );

	SSD_REGWB(0x402, 0x80);	// Reset the JPEG codec

	// Disable the interrupt so as to be able to clear the status
	SSD_REGWB(0x386, 0x00);	// JPEG interrupt control register 0
	SSD_REGWB(0x387, 0x00);	// JPEG interrupt control register 1 -> Reflect status at 383h

	SSD_REGWB(0x382, 0x8F);	// Clear the status register
	SSD_REGWB(0x383, 0x30);	// Clear the status register

	// clear the JPEG control registers
	SSD_REGWB(0x386, 0x87);	// JPEG interrupt control register 0
	SSD_REGWB(0x387, 0x36);	// JPEG interrupt control register 1 -> Reflect status at 383h
	SSD_REGWB(0x3A0, 0x12);	// Trigger when more than 4 bytes in FIFO & configure as output

	// Initialize the JPEG Codec registers
	SSD_REGWB(0x400, 0x09);	// still JPEG encode, bit 5 determine MJPEG(1) or still JPEG(0)
							// YUV format is 4:2:2

	while(SET_CAM_WIDTH >= (jpeg_width*=2))
	{
		count_h++;
	}

	while(SET_CAM_HEIGHT >= (jpeg_height*=2))
	{
		count_v++;
	}

	SSD_REGWB(REG_DV_JHDEC_RATIO, count_h);
	SSD_REGWB(REG_DV_JVDEC_RATIO, count_v);

	// since we encode as YUV 422, the horizontal must be multiple of 16, vertical multiple of 8
	if(exp_jpeg_width%16 !=0)
		exp_jpeg_width = ((exp_jpeg_width/16)*16)*(1<<count_h);
	else
		exp_jpeg_width = exp_jpeg_width*(1<<count_h);

	if(exp_jpeg_height%8 !=0)
		exp_jpeg_height = ((exp_jpeg_height/8)*8)*(1<<count_v);
	else
		exp_jpeg_height = exp_jpeg_height*(1<<count_v);

	// Set horizontal buffer
	line_buf = exp_jpeg_width/(1<<(SSD_REGRB(REG_DV_JHDEC_RATIO)+2)) -1;
	SSD_REGWW(0x164, line_buf);

	// Set Vertical buffer
	vert_buf = exp_jpeg_height/(1<<(SSD_REGRB(REG_DV_JVDEC_RATIO))) -1;
	SSD_REGWW(0x168, vert_buf);

	hpixel = exp_jpeg_width;
	vpixel = exp_jpeg_height;

	// Input resolution of image
	hpixel_8 = hpixel & 0x00FF;
	SSD_REGWB(0x9F6, hpixel_8);		// size of image before encoding - horizontal, lower byte

	hpixel_8 = (hpixel>>8) & 0x00FF;
	SSD_REGWB(0x9F4, hpixel_8);		// size of image before encoding - horizontal, higher byte

	vpixel_8 = vpixel & 0x00FF;
	SSD_REGWB(0x9F2, vpixel_8);		// size of image before encoding - vertical, lower byte

	vpixel_8 = (vpixel>>8) & 0x00FF;
	SSD_REGWB(0x9F0, vpixel_8);		// size of image before encoding - vertical, higher byte

	max_size = (256*1024) - encoded_jpeg_addr;

	// Initi JPEG module registers
	SSD_REGWL(0x410, raw_jpeg_addr>>2);	// source address
	SSD_REGWL(0x414, encoded_jpeg_addr>>2);	// destination address
	SSD_REGWB(0x3A4, 0x0F);			// 0 = 4K F = 64K for JPEG FIFO
	SSD_REGWL(0x3B0, max_size);		// set max encode size in byte - max is 0x1A0000 due to 256K RAM
	SSD_REGWB(0x380, 0x11);			// turn on the YUV output data range 1, and turn on module

	return;
}

UINT32 Start_JPEG_Encode(void)
{
	UINT8 status, temp;
	UINT8 JRStatus0, JStatus1, JStatus0;
	UINT32 filesize;

	UINT32 i =0;

	// reset camera
	cam_reset();
	delay_ms(100);

 	SSD_REGWB(REG_DV_OP_MODE, (SSD_REGRB(REG_DV_OP_MODE)|0x80));    //Enable jpeg capture in camera interface
	SSD_REGWB(0x402, 0x01);		// 	Start JPEG operation
	SSD_REGWB(0x38A, 0x01);		//  Start the frame capturing

	while ( i < 0xFFFF)
	{
		status = SSD_REGRB(0x404);
		if ( status == 0x00 )	// status 0 meaning JPEG codec is idling
		{
			filesize = SSD_REGRL(0x3B4);
			JStatus0 = SSD_REGRB(0x382);
			//JStatus1 = SSD_REGRB(0x383);
			//JRStatus0 = SSD_REGRB(0x385);
			//myprintf("file size 0x%x, 382 = 0x%x, 383 = 0x%x, 385 = 0x%x \r\n", filesize, JStatus0,JStatus1, JRStatus0 );
			JStatus1 = SSD_REGRB(0x383)& 0x02;
			JRStatus0 = SSD_REGRB(0x385)& 0x02;
			if ( filesize == 0 || JStatus1 != 0x02 || JRStatus0 != 0x02)
			{
				// still in encoding process
				i++;
				if(i == 0xFFFF)
					return -1;
			}
			else
			{
				myprintf("Encode completed\r\n");
				return filesize;
			}
		}
		i++;
	}
}

void Write_JPEG_data_to_192x(UINT32 filesize)
{
	UINT32 i=0;
	UINT32 encoded_jpeg_address;

	UINT8 t;

	encoded_jpeg_address = (SSD_REGRL(0x414))<<2;
	//myprintf("encoded_jpeg_address is 0x%x\r\n", encoded_jpeg_address);

	for(i = 0 ; i < filesize; i++)
	{
		t = jpeg_encode[i] = SSD_MEMRB(encoded_jpeg_address+i);
	}

	jfilesize = filesize;

	// to be remove
	//print_encode();

	myprintf("file size is 0x%x & had written to external Flash\r\n", filesize);
	return;
}


UINT8 Write_JPEG_data_to_SD(UINT32 fsize, UINT8 index)
{
	FATFS fs;         			// Work area (file system object) for logical drive
	FIL fdst;   				// file objects
	FRESULT res, close, umount; // FatFs function common result code
	UINT bw;      				// File R/W count

	UINT32 i = 0;
	char do_again = 0;

	UINT8 file_ext[5] = ".jpg";
	UINT8 file_name[8] = "JPEG";
	UINT8 file_index[3];

	UINT32 en_jpeg_address;
	en_jpeg_address = (SSD_REGRL(0x414))<<2;

	sprintf(file_index, "%d", index);
	strcat(file_name, file_index);
	strcat(file_name, file_ext);

	myprintf("File name = %s \r\n", file_name);

	for(i = 0 ; i < fsize; i++)
	{
		jpeg_encode[i] = SSD_MEMRB(en_jpeg_address+i);
	}

	jfilesize = fsize;

	//print_encode();

rewrite:

	res = Init_SD();
	if ( res != 0)
	{
		myprintf("SD initialized have problem\r\n");
		return res;
	}

	myprintf("Write to SD, file size is 0x%x\r\n", fsize);

	// Register a work area for logical drive 0
	res = f_mount(0, &fs);
	if (res != 0)
	{
		goto errlog;
	}
	myprintf("Mounted !\r\n");

	res = f_open(&fdst, file_name, FA_CREATE_ALWAYS | FA_WRITE);
	if (res != 0)
	{
		goto errlog;

	}
	myprintf("File opened !\r\n\n");
	for(i = 0 ; i < fsize; i++)
	{
		jpeg_encode[i] = SSD_MEMRB(en_jpeg_address+i);
	}
	//res = f_write(&fdst, jpeg_encode, sizeof(jpeg_encode), &bw);
	res = f_write(&fdst, jpeg_encode, fsize, &bw);

errlog:

	close = f_close(&fdst);

	umount = f_mount(0, NULL);

	if ( res != 0 || close !=0 || umount != 0)
	{
		do_again++;
		myprintf("res = %d, close = %d, umount = %d, try = %d\r\n\n", res, close, umount, do_again);
	}
	else
	{
		do_again = 0;
		myprintf("File %s written !\r\n\n", file_name);
		return 0;
	}

	if ( do_again != 0 && do_again <= 3)
	{
		SSD192x_hard_reset();
		long_delay(0x100);
		goto rewrite;
	}

	return -1;

}

void print_encode(void)
{
	// for debugging purpose, print out the JPEG data on screen
	UINT8 t;
	UINT32 i;

	UART0_SendString("Hit '.' to capture LOG\r\n");
	while(UART0_GetByte() != '.');

	for(i = 0 ; i < jfilesize; i++)
	{
			t = jpeg_encode[i];
			if(t <= 0x0F)
				myprintf("0%x ",t);
			else
				myprintf("%x ",t);
	}
}

